package internal.oa;

import internal.OrderingAgent;
import jade.core.AID;
import jade.lang.acl.ACLMessage;
import jade.proto.SimpleAchieveREInitiator;
import misc.AgentHelper;

	// handles sending reminders to WhAs who are late 
	class ReminderBehaviour extends SimpleAchieveREInitiator {

		private final OrderingBehaviour theMaster;
		private int result = 1;
		private final OrderingAgent theAgent;

		public ReminderBehaviour(OrderingBehaviour master,
				ACLMessage reminderMessage) {
			super(master.theAgent, reminderMessage);
			this.theMaster = master;
			theAgent = theMaster.theAgent;
		}

		protected void handleFailure(ACLMessage msg) {
			result = 1;
		}

		// WhA sent new delivery confirmation
		protected void handleInform(ACLMessage msg) {
			theMaster.theConfirmation = OAHelper.extractConfirmation(theAgent, msg);
			result = 0;
		}

		// WhA refused
		protected void handleRefuse(ACLMessage msg) {
			result = 1;
		}

		// prepares reminder request to WhA
		protected ACLMessage prepareRequest(ACLMessage msg) {
			// extract message received from LA
			ACLMessage reminder = (ACLMessage) theMaster.laCommandMessage.clone();
			reminder.clearAllReceiver();
			reminder.clearAllReplyTo();
			reminder.setSender(myAgent.getAID());
			reminder.addReplyTo(myAgent.getAID());
			// direct it to the offending WhA
			AID receiver = OAHelper.extractConfirmation(theAgent, theMaster.laCommandMessage).getOfferDescription()
					.getAgentAID();
			reminder.addReceiver(receiver);
			AgentHelper.debugMessage(this.myAgent, "reminding "
					+ receiver.getLocalName());
			return reminder;
		}

		public int onEnd() {
			return result;
		}
	}