package internal.oa;

import internal.OrderingAgent;
import jade.core.behaviours.SimpleBehaviour;
import jade.lang.acl.ACLMessage;

import java.util.Iterator;

import misc.AgentHelper;
import ontology.LAAgentDescription;

// sends cfps to WhAs we got adresses of
public class SendCFPBehaviour extends SimpleBehaviour {

	private final OrderingBehaviour theMaster;
	private int result = 1;
	private final OrderingAgent theAgent;

	public SendCFPBehaviour(OrderingBehaviour behaviour) {
		this.theMaster = behaviour;
		theAgent = theMaster.theAgent;
	}

	public void action() {
		// get template of CFP
		ACLMessage template = theMaster.cfpTemplate;

		// generate CFPs to every supplier based on the template...
		for (Iterator iter = theMaster.theSuppliers.iterator(); iter.hasNext();) {
			LAAgentDescription wha = (LAAgentDescription) iter.next();
			ACLMessage newMsg = (ACLMessage) template.clone();
			newMsg.addReceiver(wha.getAgentAID());
			newMsg.setConversationId(AgentHelper.createConvId(theAgent, "order"));
			// ... and send them
			myAgent.send(newMsg);
		}

		AgentHelper.debugMessage(theAgent, "sent out "
				+ theMaster.theSuppliers.size() + " CFPs");

		// we cannot fail unless there was a runtime error before we reached this line
		result = 0;
	}

	// we are done
	public boolean done() {
		return true;
	}

	// result for FSM
	public int onEnd() {
		return result;
	}
}
