package misc;

import jade.core.Agent;

/**
 * 
 * Helper class for centralised debug/error reporting and Conversation ID generation.
 * Encapsulates helper functions used by agents.
 *
 */
public class AgentHelper {
	public static int debugMode = 0;
	public static int scenario = 1;

	public AgentHelper() {
	}

	public static String createConvId(Agent agent, String action) {
		return action + agent.getName() + System.currentTimeMillis();
	}

	public static boolean debugMessage(Agent agent, String message) {
		if (debugMode < 1)
			System.out.println(agent.getLocalName() + ":"
					+ agent.getClass().getName() + ": " + message);
		return true;
	}

	public static boolean errorMessage(Agent agent, String message) {
		if (debugMode < 2)
			System.err.println(agent.getLocalName() + ":"
					+ agent.getClass().getName() + ": " + message);
		return true;
	}
}