package misc;

/**
 * 
 * Used for running the logistics agent system.
 *
 */
public class AgentStart {
	private static String[] jadeArgs;

	public AgentStart() {
	}

	/**
	 * Following parameters are used:
	 * 1. scenario number
	 * 2. debug mode (0, 1, 2)
	 * 		0 - normal mode (debug plus errors)
	 * 		1 - suppress all debug messages (errors only)
	 * 		2 - suppress all messages (silent mode)
	 */
	public static void main(String[] args) {
		try {
			if (args.length < 2) {
				System.out.println("Not enough params!");
				System.out.println("Run using:");
				System.out.println("  AgentStart SCENARIO DEBUGMODE");
				System.out.println("SCENARIO={1,2} DEBUGMODE={0,1,2}");
				return;
			}

			if (args[0] != null)
				setScenario(Integer.parseInt(args[0]));

			if (args[1] != null)
				setDebugMode(Integer.parseInt(args[1]));

			// start JADE platform
			jade.Boot.main(jadeArgs);
			System.out.println("Jade Inited()");
			System.out.println("Start");
		} catch (Exception ex) {
			System.out.println(ex);
		}
	}

	private static void setDebugMode(int i) {
		AgentHelper.debugMode = i;
	}

	/**
	 * Scenarios:
	 * 1. No delivery notification, ordering is repeated until deadline.
	 * 2. Delivery notification, ordering succeeds.
	 */
	private static void setScenario(int i) {
		//		 set parameters for JADE platform
		String[] args = { "-gui", "la:internal.LogisticsAgent",
				"cic:internal.CICAgent", "wa:internal.WarehouseAgent",
				"sda:internal.SDAgent", "oa1:internal.OrderingAgent",
				"oa2:internal.OrderingAgent", "wha1:external.WholesalerAgent",
				"wha2:external.WholesalerAgent"};
		jadeArgs = args;
		AgentHelper.scenario = i;
	}
}
